
/*

 CODE4-TO-CODE5.PRG

 05-10-2022

 www.cobasystems.com --- COBA Systems --- Slobodan Stanojevi COBA
 Open Source Project BAST Business Account Software Technology
 www.Alaska-Software.com --- Alaska Xbase++ version 2.0.1503
 www.Donnay-software.com --- eXpress++      version 2.0.268
 https://devzone.advantagedatabase.com/dz/
 SAP --- Advantage Database Server ADS      version 10.10.0.49
 Sergej Spirin --- FastReport for Xbase++   version 27.03.2015
 ======================================================================

 Program: CODE4-TO-CODE5.PRG

 KAKO REITI PRELAZ SA IFRE OD 4 ZNAKA NA IFRU OD 5 ZNAKOVA:

 U registar kupaca moe se upisati samo 9999 kupaca
 sa iframa od "0000" do "9999"

 Korisnik trai da u registar moe da upie do 50000 kupaca

 Da se ne bi menjao registar kupaca i baza podataka kupaca
 a i sve ostale aplikacije koje rade sa podacima o kupcima
 koristei ifru kupca sa 4 znaka, treba omoguiti unos kupaca
 od ifre "0000" do ifre "50000" ali da ifra kupca u bazi
 podataka ostane sa 4 znaka.

 To je uraeno preko heksadecimalnih brojeva tehnologijom
 koja je data u ovom programu.
 Autor: Dragan Blagojevi - Blagoje
 ----------------------------------

 HOW TO SOLVE THE TRANSITION
 FROM A 4-CHARACTER CODE TO A 5-CHARACTER CODE:

 Only 9999 customers can be registered in the customer register
 with codes from "0000" to "9999"

 The user requests that he can enter up to 50,000 customers in the
 register

 In order not to change the customer register and the customer
 database and all other applications that work with customer data
 using a 4-character customer code, customer entry should be enabled
 from the code "0000" to the code "50000" but the customer's code in
 the database data remains with 4 characters.

 This is done over hexadecimal numbers using the technology
 provided in this program.
 Author: Dragan Blagojevi - Blagoje
 -----------------------------------

 ======================================================================
*/



// #include "adsdbe.ch" // ADS server
// #include "ads.ch"    // ADS server
// #include "Dmlb.ch"   // fieldinfo()
// #include "Gra.ch"
// #include "Font.ch"
// #include "color.ch"
// #include "dll.ch"


 #include "Appevent.ch"
 #include "Xbp.ch"
 #include "common.ch"
 #include "xbtsys.ch"  // XbToolsIII++ library

 #pragma library("dclipx.lib")  // eXpress++ library
 #include "dcdialog.ch"

 #pragma library("ot4xb.lib")   // ot4xb library
 #include "ot4xb.ch"


************************************************
PROCEDURE APPSYS()
************************************************
 SET CHARSET TO ANSI
 SET DATE GERMAN
 SET CENTURY ON
RETURN

************************************************
PROCEDURE MAIN()
************************************************
LOCAL GetList := {}, GetOptions, oDlg, oBrowse
LOCAL radno:=SELECT(); oCur:={"user32.dll",114}

@ 1,1 DCSAY "TEST CODE4-TO-CODE5"

@ 5,1 DCPUSHBUTTON CAPTION "CODE4-TO-CODE5" SIZE 20,2 ;
       ACTION {|| writer(), DC_GetRefresh(GetList) }

@ 7,1 DCPUSHBUTTON CAPTION "EXIT" SIZE 20,2 ;
       ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

DCGETOPTIONS NOESCAPEKEY NOMINBUTTON NOMAXBUTTON

DCREAD GUI ;
TITLE "COBA Systems" ;
OPTIONS GetOptions ;
        FIT ;
        PARENT @oDlg ;
        MODAL ;
        EVAL {|o| SetAppWindow(o) }

SELECT(radno)
RETURN


************************************************
FUNCTION writer()
************************************************
/*
* AUTOIT script koji daje isto reenje
* Script je u prilogu na kraju ovog PRG modula
* AUTOIT script that gives the same solution
* The script is attached at the end of this PRG module

* Primenjeno u Xbase++
* Implemented in Xbase++

aNiz:={}
for i=10000 to 10030
 DELETE fILE t.txt
 ccc:= "/C cs4.exe "+var2char(i) +" > t.txt"
 ddd:= '"'+ccc+'"'
 qq:=Runshell(ddd)
 fff:=alltrim(memoread("t.txt"))
 AADD(aniz,{i,fff})
next i
aPRINT(aNiz)
*/



* Primenjeno u Xbase++ uz upotrebu ot4xb.dll/lib/ch
* Implemented in Xbase++ using ot4xb.dll/lib/ch
*    Convert a WORD numeric value into a hexadecimal string
*    cW2Hex( nW ) -> cHex

aNiz:={}
for i=(30960+10000) to (30960+10030) STEP 1
   cHex := cW2Hex( i )    // ot4xb.dll
 AADD(aNiz,{i,cHex})
next i
aPRINT(aNiz)

RETURN NIL


STATIC FUNCTION aPRINT(aNiz)

LOCAL ctxt := "CodeList.txt"
DELETE FILE (ctxt)
SET PRINTER TO (ctxt)
SET PRINT ON
SET CONSOLE OFF
SET MARGIN TO 2

    for j=1 to len(aNiz)

    ? var2char(aNiz[j,1]-30960)+" ---> "+aNiz[j,2]

    next j

SET PRINTER TO
SET PRINT OFF
SET CONSOLE ON
SET MARGIN TO 0

RUNSHELL("CodeList.txt","NOTEPAD.EXE")

RETURN NIL



/*

AUTOIT CODE

#cs ---------------------------------------------------------------------------
	AutoIt Verzija: 3.3.16.1
	Autor:
	Dragan Blagojevic
	02.10.2022.god.

	Funnkcija skripta:
	Vidi dokument Coba_sifra_4.pdf
	-----------------------------------
	Preuzima parametar iz komandne linije i od njega
	pravi "hibridnu" sifru duzine 4 znaka sa vod. 0.

	Pozivanje:
	cs4 10000 iz komandne linije
	RunShell("10000", "sc4.exe") iz Aljaske

	Vraca:
	Hibridnu sifru i ExitCode = 0 ako je poziv uspesan.
	ExitCode = 1 ako je poziv bez parametra.
        0 i ExitCode = 0 ako se prosledi string kao param.

	Napomena: Ne proverava da li je parametar <= 65535 (FFFF).

	---
        AutoIt Version: 3.3.16.1
        Author: Dragan Blagojevic
        02.10.2022

        Script function:
        See the document Coba_sifra_4.pdf
        --------------------------------------
        Takes a parameter to and from the command line
        creates a "hybrid" code of length 4 characters from vod. 0.

        Calling:
        cs4 10000 from the command line
        RunShell("10000", "sc4.exe") from Alaska

        Returns:
        Hybrid code and ExitCode = 0 if the call is successful.
        ExitCode = 1 if the call is parameterless.
        0 and ExitCode = 0 if string is passed as param.

        Note: It does not check if the parameter is <= 65535 (FFFF).


#ce ---------------------------------------------------------------------------

; Kompajlirati kao konzolnu aplikaciju
; Compile as a console application
#pragma compile(Console, True)


; Pocetak skripta
; The beginning of the script

; Inicijalizacija promenljivih
; Initialization of variables
Local $CMD_LINE_PAR = 0 ; Number
Local $RESULT = ""            ; String

; Ucitavanje parametra komande linije i pozivanje funkcije
; Ukupan broj elemenata u nizu parametara komandne linije
; Loading a command line parameter and calling a function
; The total number of elements in the command line parameter array

  IF $CmdLine[0] > 0 Then
	  ; Prvi parametar komandne linije
	  ; The first command line parameter
	  $CMD_LINE_PAR = Number($CmdLine[1])
	  If IsNumber($CMD_LINE_PAR) = 1 Then
	      $RESULT = Convert($CMD_LINE_PAR)
	      ConsoleWrite($RESULT)
	  Else
	      Exit(1)
	  EndIf
  Else
     Exit(1)
EndIf

; Funkcija
Func Convert($NSIFRA)
   $NSIFRA_ZA_BAZU = 0  ; Number
   $SSIFRA_ZA_BAZU = "" ; String

    If $NSIFRA > 9999 Then
		$NSIFRA_ZA_BAZU = $NSIFRA + 30960
		$SSIFRA_ZA_BAZU = HEX($NSIFRA_ZA_BAZU, 4)
		Return $SSIFRA_ZA_BAZU
    Else
		$SSIFRA_ZA_BAZU = StringFormat("%04s", $NSIFRA)
	    Return $SSIFRA_ZA_BAZU
   EndIf
EndFunc





;DOKUMENTACIJA Coba_sifra_4.pdf
;DOCUMENTATION Coba_sifra_4.pdf


*/
